%global git b9ed12bc3c6b84c6bd2955bc07d7f03760f237ad

Name:           php-saml-sp
Version:        0.3.0
Release:        0.54%{?dist}
Summary:        SAML Service Provider library

License:        MIT
URL:            https://software.tuxed.net/php-saml-sp
%if %{defined git}
Source0:        https://git.tuxed.net/fkooman/php-saml-sp/snapshot/php-saml-sp-%{git}.tar.xz
%else
Source0:        https://software.tuxed.net/php-saml-sp/files/php-saml-sp-%{version}.tar.xz
Source1:        https://software.tuxed.net/php-saml-sp/files/php-saml-sp-%{version}.tar.xz.minisig
Source2:        minisign-8466FFE127BCDC82.pub
%endif
Source3:        %{name}-httpd.conf

Patch0:         %{name}-autoload.patch

BuildArch:      noarch

BuildRequires:  minisign
BuildRequires:  php-fedora-autoloader-devel
BuildRequires:  %{_bindir}/phpab
#    "require-dev": {
#        "phpunit/phpunit": "^4|^5|^6|^7",
#    },
%if 0%{?fedora} >= 28 || 0%{?rhel} >= 8
BuildRequires:  phpunit7
%global phpunit %{_bindir}/phpunit7
%else
BuildRequires:  phpunit
%global phpunit %{_bindir}/phpunit
%endif
#    "require": {
#        "ext-date": "*",
#        "ext-dom": "*",
#        "ext-filter": "*",
#        "ext-hash": "*",
#        "ext-libxml": "*",
#        "ext-openssl": "*",
#        "ext-pcre": "*",
#        "ext-spl": "*",
#        "ext-zlib": "*",
#        "fkooman/secookie": "^4",
#        "paragonie/constant_time_encoding": "^1|^2",
#        "paragonie/random_compat": ">=1",
#        "php": ">=5.4",
#        "symfony/polyfill-php56": "^1"
#    },
BuildRequires:  php(language) >= 5.4.0
BuildRequires:  php-date
BuildRequires:  php-dom
BuildRequires:  php-filter
BuildRequires:  php-hash
BuildRequires:  php-libxml
BuildRequires:  php-openssl
BuildRequires:  php-pcre
BuildRequires:  php-spl
BuildRequires:  php-zlib
BuildRequires:  php-composer(fkooman/secookie) >= 4
BuildRequires:  php-composer(fkooman/secookie) < 5
BuildRequires:  php-composer(paragonie/constant_time_encoding)
%if 0%{?fedora} < 28 && 0%{?rhel} < 8
BuildRequires:  php-composer(paragonie/random_compat)
BuildRequires:  php-composer(symfony/polyfill-php56)
%endif

#    "require": {
#        "ext-date": "*",
#        "ext-dom": "*",
#        "ext-filter": "*",
#        "ext-hash": "*",
#        "ext-libxml": "*",
#        "ext-openssl": "*",
#        "ext-pcre": "*",
#        "ext-spl": "*",
#        "ext-zlib": "*",
#        "fkooman/secookie": "^4",
#        "paragonie/constant_time_encoding": "^1|^2",
#        "paragonie/random_compat": ">=1",
#        "php": ">=5.4",
#        "symfony/polyfill-php56": "^1"
#    },
Requires:       php(language) >= 5.4.0
Requires:       php-date
Requires:       php-dom
Requires:       php-filter
Requires:       php-hash
Requires:       php-libxml
Requires:       php-openssl
Requires:       php-pcre
Requires:       php-spl
Requires:       php-zlib
Requires:       php-composer(fkooman/secookie) >= 4
Requires:       php-composer(fkooman/secookie) < 5
Requires:       php-composer(paragonie/constant_time_encoding)
%if 0%{?fedora} < 28 && 0%{?rhel} < 8
Requires:       php-composer(paragonie/random_compat)
Requires:       php-composer(symfony/polyfill-php56)
%endif

%if 0%{?fedora} >= 24
Requires:   httpd-filesystem
%else
# EL7 does not have httpd-filesystem
Requires:   httpd
%endif

Provides:       php-composer(fkooman/saml-sp) = %{version}
Conflicts:      php-fkooman-saml-sp

Requires(post): /usr/bin/openssl

%description
This library allows adding SAML Service Provider (SP) support to your PHP web
application.

%prep
%if %{defined git}
%setup -qn php-saml-sp-%{git}
%else
/usr/bin/minisign -V -m %{SOURCE0} -x %{SOURCE1} -p %{SOURCE2}
%setup -qn php-saml-sp-%{version}
%endif
%patch0 -p1

%build
%{_bindir}/phpab -t fedora -o src/autoload.php src
cat <<'AUTOLOAD' | tee -a src/autoload.php
require_once '%{_datadir}/php/ParagonIE/ConstantTime/autoload.php';
require_once '%{_datadir}/php/fkooman/SeCookie/autoload.php';
AUTOLOAD
%if 0%{?fedora} < 28 && 0%{?rhel} < 8
cat <<'AUTOLOAD' | tee -a src/autoload.php
require_once '%{_datadir}/php/random_compat/autoload.php';
require_once '%{_datadir}/php/Symfony/Polyfill/autoload.php';
AUTOLOAD
%endif

%install
mkdir -p %{buildroot}%{_datadir}/php/fkooman/SAML/SP
cp -pr src/* %{buildroot}%{_datadir}/php/fkooman/SAML/SP

mkdir -p %{buildroot}%{_datadir}/%{name}
cp -pr views locale web %{buildroot}%{_datadir}/%{name}

mkdir -p %{buildroot}%{_sysconfdir}/%{name}
cp -pr config/config.php.example %{buildroot}%{_sysconfdir}/%{name}/config.php
ln -s ../../../etc/%{name} %{buildroot}%{_datadir}/%{name}/config

ln -s ../../../etc/pki/%{name} %{buildroot}%{_datadir}/%{name}/keys

mkdir -p %{buildroot}%{_sysconfdir}/pki/%{name}/private

# httpd
install -m 0644 -D -p %{SOURCE3} %{buildroot}%{_sysconfdir}/httpd/conf.d/%{name}.conf

%check
%{_bindir}/phpab -o tests/autoload.php tests
cat <<'AUTOLOAD' | tee -a tests/autoload.php
require_once 'src/autoload.php';
AUTOLOAD

%{phpunit} tests --verbose --bootstrap=tests/autoload.php

%post
for TYPE in encryption signing
do
    if [ ! -f "%{_sysconfdir}/pki/%{name}/private/${TYPE}.key" ]
    then
        # generate the key
        /usr/bin/openssl \
            req \
            -nodes \
            -subj "/CN=SAML SP (${TYPE})" \
            -x509 \
            -sha256 \
            -newkey rsa:3072 \
            -keyout "%{_sysconfdir}/pki/%{name}/private/${TYPE}.key" \
            -out "%{_sysconfdir}/pki/%{name}/${TYPE}.crt" \
            -days 1825 \
            2>/dev/null
        # fix the permissions
        chmod 0640 %{_sysconfdir}/pki/%{name}/private/${TYPE}.key %{_sysconfdir}/pki/%{name}/${TYPE}.crt
        chgrp apache %{_sysconfdir}/pki/%{name}/private/${TYPE}.key %{_sysconfdir}/pki/%{name}/${TYPE}.crt
    fi
done

%files
%config(noreplace) %attr(0750, root, apache) %{_sysconfdir}/pki/%{name}
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
%dir %attr(0750,root,apache) %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/config.php
%{_datadir}/%{name}
%dir %{_datadir}/php/fkooman
%dir %{_datadir}/php/fkooman/SAML
%{_datadir}/php/fkooman/SAML/SP
%license LICENSE
%doc composer.json CHANGES.md README.md

%changelog
* Tue Feb 11 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.54
- rebuilt

* Mon Feb 10 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.53
- rebuilt

* Mon Feb 10 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.52
- rebuilt

* Mon Feb 10 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.51
- rebuilt

* Mon Feb 10 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.50
- rebuilt

* Mon Feb 10 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.49
- rebuilt

* Mon Feb 10 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.48
- rebuilt

* Mon Feb 10 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.47
- rebuilt

* Mon Feb 10 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.46
- rebuilt

* Mon Feb 03 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.45
- rebuilt

* Fri Jan 31 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.44
- rebuilt

* Fri Jan 31 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.43
- rebuilt

* Fri Jan 31 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.42
- rebuilt

* Thu Jan 30 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.41
- rebuilt

* Thu Jan 30 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.40
- rebuilt

* Thu Jan 30 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.39
- rebuilt

* Thu Jan 30 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.38
- rebuilt

* Wed Jan 29 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.37
- rebuilt

* Wed Jan 29 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.36
- rebuilt

* Wed Jan 29 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.35
- rebuilt

* Wed Jan 29 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.34
- rebuilt

* Tue Jan 28 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.33
- rebuilt

* Tue Jan 28 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.32
- rebuilt

* Tue Jan 28 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.31
- rebuilt

* Mon Jan 27 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.30
- rebuilt

* Mon Jan 27 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.29
- rebuilt

* Mon Jan 27 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.28
- rebuilt

* Fri Jan 24 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.27
- rebuilt

* Fri Jan 24 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.26
- rebuilt

* Fri Jan 24 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.25
- rebuilt

* Thu Jan 23 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.24
- rebuilt

* Wed Jan 22 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.23
- rebuilt

* Wed Jan 22 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.22
- rebuilt

* Wed Jan 22 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.21
- rebuilt

* Wed Jan 22 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.20
- rebuilt

* Wed Jan 22 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.19
- rebuilt

* Wed Jan 22 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.18
- rebuilt

* Wed Jan 15 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.17
- rebuilt

* Tue Jan 14 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.16
- rebuilt

* Tue Jan 14 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.15
- rebuilt

* Tue Jan 14 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.14
- rebuilt

* Tue Jan 14 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.13
- rebuilt

* Tue Jan 14 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.12
- rebuilt

* Tue Jan 14 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.11
- rebuilt

* Tue Jan 14 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.10
- rebuilt

* Tue Jan 14 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.9
- rebuilt

* Tue Jan 14 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.8
- rebuilt

* Tue Jan 14 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.7
- rebuilt

* Tue Jan 14 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.6
- rebuilt

* Tue Jan 14 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.5
- rebuilt

* Tue Jan 14 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.4
- rebuilt

* Mon Jan 13 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.3
- rebuilt

* Mon Jan 13 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.2
- rebuilt

* Mon Jan 13 2020 François Kooman <fkooman@tuxed.net> - 0.3.0-0.1
- update to 0.3.0

* Tue Aug 06 2019 François Kooman <fkooman@tuxed.net> - 0.2.2-1
- update to 0.2.2

* Mon Aug 05 2019 François Kooman <fkooman@tuxed.net> - 0.2.1-1
- update to 0.2.1
- switch to minisign signature verification for release builds

* Wed Jul 31 2019 François Kooman <fkooman@tuxed.net> - 0.2.0-1
- update to 0.2.0

* Tue Apr 23 2019 François Kooman <fkooman@tuxed.net> - 0.1.1-1
- update to 0.1.1

* Fri Mar 15 2019 François Kooman <fkooman@tuxed.net> - 0.1.0-1
- initial package
